function [W,K,Lower_Bound] = Dense1_QCQP(A,B,C,X0,p,L,Q,R,epsi,alpha1,alpha2,solver)

cvx_begin 

if solver==0,
    cvx_solver mosek
elseif solver==1
    cvx_solver SDPT3
else
    cvx_solver sedumi
end


cvx_precision best

n= size(A,1);
m= size(B,2);
r= size(C,1);

s=sum(sum(L));
RR=L*ones(r,1);
total=0;
for i=1:m,
    for j=1:r,
        total = total + L(i,j);
        if (L(i,j)==1)
        addr(total,:)=[i j];
        end
    end
end


[QT,LQT]=eig(Q);
[RT,LRT]=eig(R);

variable W(1+s+(p+1)*n+(p+1)*m,1+s+(p+1)*n+(p+1)*m) symmetric
expression tt(p+1,m)


Kvec=W(2:(s+1),1);
Xvec=W(s+2:(s+2)+n*(p+1)-1,1);
Uvec=W((s+2)+n*(p+1):(s+2)+n*(p+1)+m*(p+1)-1,1);



Ab=QT'*A*QT;
Bb=QT'*B*RT;
Cb=C*QT';

som=0;
for i=1:p+1,
        for j=1:m,
            tt(i,j)=0;
            for q=1:RR(j),
              tt(i,j)=tt(i,j)+Cb(addr(som+q,2),:)*(W(som+q+1,2+s+n*(i-1):2+s+n*i-1))';
            end
            
            som=som+RR(j);
        end
        som=0;
end



minimize (trace(kron(eye(p+1),LQT)*W(s+2:1+s+n*(p+1),s+2:1+s+n*(p+1)))+...
    trace(kron(eye(p+1),LRT)*W(s+2+n*(p+1):1+s+(p+1)*(n+m),s+2+n*(p+1):1+s+(p+1)*(n+m)))+...
    alpha1*trace(W(2:s+1,2:s+1))+epsi*trace(W))



subject to

W(1,1) == 1;
Xvec(1:n)==QT'*X0;
W == semidefinite(1+s+(p+1)*n+(p+1)*m);

alpha2*(diag(W(2:s+1,2:s+1)))<=1;

for i=1:p,
    Ab*Xvec(n*(i-1)+1:n*i)+Bb*Uvec(m*(i-1)+1:m*i) == Xvec(n*i+1:n*(i+1));
end

for i=1:p,
    for j=1:p,
    
    W(2+s+i*n:2+s+n*(i+1)-1,2+s+j*n:2+s+n*(j+1)-1)==(Ab*W(2+s+(i-1)*n:2+s+n*(i)-1,2+s+(j-1)*n:2+s+n*(j)-1)*Ab')+...
        (Ab*W(2+s+(i-1)*n:2+s+n*(i)-1,2+s+n*(p+1)+(j-1)*m:2+s+n*(p+1)+m*(j)-1)*Bb')+...
        (Bb*W(2+s+n*(p+1)+(i-1)*m:2+s+n*(p+1)+m*(i)-1,2+s+(j-1)*n:2+s+n*(j)-1)*Ab')+...
        (Bb*W(2+s+n*(p+1)+(i-1)*m:2+n*(p+1)+s+m*(i)-1,2+s+n*(p+1)+(j-1)*m:2+s+n*(p+1)+m*(j)-1)*Bb');     
  
    end
end


for i=1:p,
    for j=1:p,
            W(2+s+i*n:2+s+n*(i+1)-1,2+s+j*n:2+s+n*(j+1)-1) == (Ab*W(2+s+(i-1)*n:2+s+n*(i)-1,2+s+(j-1)*n:2+s+n*(j)-1)*Ab')+...
        (Ab*W(2+s+(i-1)*n:2+s+n*(i)-1,2+s+n*(p+1)+(j-1)*m:2+s+n*(p+1)+m*(j)-1)*Bb')+...
        (Bb*W(2+s+n*(p+1)+(i-1)*m:2+s+n*(p+1)+m*(i)-1,2+s+(j-1)*n:2+s+n*(j)-1)*Ab')+...
        (Bb*W(2+s+n*(p+1)+(i-1)*m:2+n*(p+1)+s+m*(i)-1,2+s+n*(p+1)+(j-1)*m:2+s+n*(p+1)+m*(j)-1)*Bb');  
  
       W(2+s+i*n:2+s+n*(i+1)-1,2+s+(j-1)*n:2+s+n*(j)-1)*Ab'+...
           W(2+s+i*n:2+s+n*(i+1)-1,2+s+n*(p+1)+(j-1)*m:2+s+n*(p+1)+m*(j)-1)*Bb'== Ab*W(2+s+(i-1)*n:2+s+n*(i)-1,2+s+j*n:2+s+n*(j+1)-1)+...
           Bb*W(2+s+n*(p+1)+(i-1)*m:2+s+n*(p+1)+m*(i)-1,2+s+j*n:2+s+n*(j+1)-1);
    end
end


for i=1:p+1,
   RT* Uvec(m*(i-1)+1:m*i) == tt(i,:)';
   
end


cvx_end

K=zeros(m,r);
i=1;
while i<s+1
    for j=1:m,
        for q=1:r,
            if L(j,q)==1
                K(j,q)= Kvec(i);
                i=i+1;
            end
        end
    end
end

Lower_Bound = trace(kron(eye(p+1),LQT)*W(s+2:1+s+n*(p+1),s+2:1+s+n*(p+1)))+...
    trace(kron(eye(p+1),LRT)*W(s+2+n*(p+1):1+s+(p+1)*(n+m),s+2+n*(p+1):1+s+(p+1)*(n+m)))+...
    alpha1*trace(W(2:s+1,2:s+1));

K=full(K);


cvx_clear

