
%%%% p = time, n= # states, m= # inputs, r= # outputs, 
%%%% (A,B,C) = discrete-time system, X0 = initial state
%%%% (Sigma_disturbance,Sigma_noise) = covariance marices of disturbance
%%%% and noise respectively
%%%% Q = state regulation, R = input regulation 
%%%% L =  binary matrix defined as sign(K)

p=40; %time
n=8; % state, 2*(number of masses)
m=n/2; % output
r=n; % input
sampling_t = 0.1; % sampling time for discretization

%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Mass-Spring
% %n=r=2*m=2*N
% 
% 
N = n/2;
I = eye(N,N);
Z = zeros(N,N);
T = toeplitz([2 -1 zeros(1,N-2)]);
Ac = [Z I; -T Z];
Bc = [Z; I];
Cc=eye(2*N);

% Discretization

sysc=ss(Ac,Bc,Cc,0);
sysd = c2d(sysc, sampling_t, 'zoh');
[A,B,C,D,J] = ssdata(sysd);

%%%%%%%%%%%%%%%%%%%%%%%%%%

Q=eye(n);
R=eye(m);
Sigma_disturbance=eye(n);
Sigma_noise=eye(r);
X0=ones(n,1);
alpha=0;
beta=0;
L=zeros(m,r);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Four different control structures

L_a = [toeplitz([1 1 zeros(1,N-2)]) toeplitz([1 1 zeros(1,N-2)])];

L_b = [toeplitz([1 1 zeros(1,N-2)]) eye(N)];

L_c = [eye(N) eye(N)]; 

L_d = [eye(N) eye(N)]; L_d(1,:)=1; L_d(:,1)=1;

for i=1:2:N,
    L_e(i,i)=1;
    L_e(i,i+N)=1;
end


for i=1:2:N,
    L_f(i,i)=1;
    L_f(i,i+N)=1;
end
L_f(1,:)=1;
L_f(N,:)=1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

L=L_a;










