function [K] = Indirect_Method_Lyap_domain(A,B,C,L,Q,R,P,Sigma_noise,alpha,beta,solver)

Sigma_noise_half=real(sqrtm(Sigma_noise));


cvx_begin 

if solver==0,
    cvx_solver mosek
elseif solver==1
    cvx_solver SDPT3
else
    cvx_solver sedumi
end


cvx_precision best

n= size(A,1);
m= size(B,2);
r= size(C,1);
P=(P+P')/2;

Sigma_noise_s=real(sqrtm(Sigma_noise));
P_half=real(sqrtm(P));
RT=real(sqrtm(R));

variable K(m,r)
variable tole
expression M(n+n+m,n+n+m)

M=[P-Q-tole*eye(n) , (A+B*K*C)' , (K*C)' ; 
    (A+B*K*C) , inv(P) , zeros(n,m) ;
    K*C , zeros(m,n) , inv(R)];
 
minimize (-tole+0.0001*vec(RT*K*Sigma_noise_half)'*vec(RT*K*Sigma_noise_half)+...
          0.0001*vec(P_half*B*K*Sigma_noise_half)'*vec(P_half*B*K*Sigma_noise_half)+...    
            0.0001*alpha*vec(K)'*vec(K))


subject to

for i=1:m,
    for j=1:r
        if L(i,j)==0;
            K(i,j)==0;
        end
    end
end

M==semidefinite(2*n+m);

beta*vec(K)'*vec(K)<=1;

cvx_end

K=full(K);



cvx_clear