function [K] = Indirect_Method_Time_Domain(A,B,C,X0,p,L,W,alpha,beta,solver)


cvx_begin 

if solver==0,
    cvx_solver mosek
elseif solver==1
    cvx_solver SDPT3
else
    cvx_solver sedumi
end


cvx_precision best

n= size(A,1);
m= size(B,2);
r= size(C,1);

variable K(m,r)
expression t

for i=1:p,
    t=[t ; (A+B*K*C)*(W(1:n,n+i))-W(1:n,n+i+1)];
end

minimize(norm(t)+alpha*vec(K)'*vec(K))

subject to

for i=1:m,
    for j=1:r
        if L(i,j)==0;
            K(i,j)==0;
        end
    end
end

    
beta*vec(K)'*vec(K)<=1;

cvx_end

K=full(K);

end

