%% Please Provide the System Dynamics and the Method:
% A, B, C, Q, R, p, alpha, beta L, options
% options will be explained when you run this code.
% Please load these required data in System_Description file
% If you would like to load your data, you can use the command load of Matlab
% You can run this solver in case you would like to try four different QCQP relaxations as explained in the paper
% solver = use 0 for mosek, 1 for SDPT3, and 2 for sedumi 
% Method = use 0 Direct Method and 1 for Indrect Method

%%
System_Description

disp('Please enter vector of variables as below')
disp(sprintf ( 'options(1) shows the SDP solver, enter 0 mosek, 1 for SDP3 and 2 for sedumi \n options(2) shows the recovery method, enter 0 for direct and 1 for indirect method \n options(3) shows the value for epsi in rank penalty') )

options=input('Please enter the 1 by 3 options vector:  ');

n=size(A,1);
m=size(B,2);
r=size(C,1);

Sigma_disturbance=Sigma_disturbance;
Sigma_noise=Sigma_noise;



switch options(1)
    case 0,
        Solver=0;
    case 1,
        Solver=1;
    case 2,
        Solver=2;
    otherwise
        Solver=1;
end

Method = options(2);
epsi = options(2);
if Method == 0,
    beta=0;
end


if epsi == 0 ,
        [WD1,KD1,Lower_Bound_D1] = Dense1_QCQP(A,B,C,X0,p,L,Q,R,epsi,alpha,beta,Solver);
    
        if Method==0,
            [Upper_Bound_D1] = Objective_Function_Time_Domain(A,B,C,X0,p,Q,R,KD1,alpha);
        else
         [KD1] = Indirect_Method_Time_Domain(A,B,C,X0,p,L,WD1,alpha,beta,Solver);
          [Upper_Bound_D1] = Objective_Function_Time_Domain(A,B,C,X0,p,Q,R,KD1,alpha);
        end
   else
      [WD1,KD1,Lower_Bound_D1] = Dense1_QCQP(A,B,C,X0,p,L,Q,R,0.0, alpha,beta,Solver); 
      [WD1,KD1,LbndD1] = Dense1_QCQP(A,B,C,X0,p,L,Q,R,epsi,alpha,beta,Solver);
      
      if Method==0,
            [Upper_Bound_D1] = Objective_Function_Time_Domain(A,B,C,X0,p,Q,R,KD1,alpha);
      else
         [KD1] = Indirect_Method_Time_Domain(A,B,C,X0,p,L,WD1,alpha,beta,Solver);
          [Upper_Bound_D1] = Objective_Function_Time_Domain(A,B,C,X0,p,Q,R,KD1,alpha);
       end
      
end
   
if epsi == 0 ,
        [WD2,KD2,Lower_Bound_D2] = Dense2_QCQP(A,B,C,X0,p,L,Q,R,epsi,alpha,beta,Solver);
    
        if Method==0,
            [Upper_Bound_D2] = Objective_Function_Time_Domain(A,B,C,X0,p,Q,R,KD2,alpha);
        else
         [KD2] = Indirect_Method_Time_Domain(A,B,C,X0,p,L,WD2,alpha,beta,Solver);
          [Upper_Bound_D2] = Objective_Function_Time_Domain(A,B,C,X0,p,Q,R,KD2,alpha);
        end
   else
      [WD2,KD2,Lower_Bound_D2] = Dense2_QCQP(A,B,C,X0,p,L,Q,R,0.0, alpha,beta,Solver); 
      [WD1,KD1,LbndD1] = Dense2_QCQP(A,B,C,X0,p,L,Q,R,epsi,alpha,beta,Solver);
      
      if Method==0,
            [Upper_Bound_D2] = Objective_Function_Time_Domain(A,B,C,X0,p,Q,R,KD2,alpha);
      else
         [KD2] = Indirect_Method_Time_Domain(A,B,C,X0,p,L,WD2,alpha,beta,Solver);
          [Upper_Bound_D2] = Objective_Function_Time_Domain(A,B,C,X0,p,Q,R,KD2,alpha);
       end
      
end

   if epsi == 0 ,
        [WS1,KS1,Lower_Bound_S1] = Sparse1_QCQP(A,B,C,X0,p,L,Q,R,epsi,alpha,beta,Solver);
    
        if Method==0,
            [Upper_Bound_S1] = Objective_Function_Time_Domain(A,B,C,X0,p,Q,R,KS1,alpha);
        else
         [KS1] = Indirect_Method_Time_Domain(A,B,C,X0,p,L,WS1,alpha,beta,Solver);
          [Upper_Bound_S1] = Objective_Function_Time_Domain(A,B,C,X0,p,Q,R,KS1,alpha);
        end
   else
      [WS1,KS1,Lower_Bound_S1] = Sparse1_QCQP(A,B,C,X0,p,L,Q,R,0.0, alpha,beta,Solver); 
      [WS1,KS1,LbndS1] = Sparse1_QCQP(A,B,C,X0,p,L,Q,R,epsi,alpha,beta,Solver);
      
      if Method==0,
            [Upper_Bound_S1] = Objective_Function_Time_Domain(A,B,C,X0,p,Q,R,KS1,alpha);
      else
         [KS1] = Indirect_Method_Time_Domain(A,B,C,X0,p,L,WS1,alpha,beta,Solver);
          [Upper_Bound_S1] = Objective_Function_Time_Domain(A,B,C,X0,p,Q,R,KS1,alpha);
       end
      
   end
   
     if epsi == 0 ,
        [WS2,KS2,Lower_Bound_S2] = Sparse2_QCQP(A,B,C,X0,p,L,Q,R,epsi,alpha,beta,Solver);
    
        if Method==0,
            [Upper_Bound_S2] = Objective_Function_Time_Domain(A,B,C,X0,p,Q,R,KS2,alpha);
        else
         [KS2] = Indirect_Method_Time_Domain(A,B,C,X0,p,L,WS2,alpha,beta,Solver);
          [Upper_Bound_S2] = Objective_Function_Time_Domain(A,B,C,X0,p,Q,R,KS2,alpha);
        end
   else
      [WS2,KS2,Lower_Bound_S2] = Sparse2_QCQP(A,B,C,X0,p,L,Q,R,0.0, alpha,beta,Solver); 
      [WS2,KS2,LbndS2] = Sparse2_QCQP(A,B,C,X0,p,L,Q,R,epsi,alpha,beta,Solver);
      
      if Method==0,
            [Upper_Bound_S2] = Objective_Function_Time_Domain(A,B,C,X0,p,Q,R,KS2,alpha);
      else
         [KS2] = Indirect_Method_Time_Domain(A,B,C,X0,p,L,WS2,alpha,beta,Solver);
          [Upper_Bound_S2] = Objective_Function_Time_Domain(A,B,C,X0,p,Q,R,KS2,alpha);
       end
      
   end


Lower_Bound_D1
Upper_Bound_D1

Lower_Bound_D2
Upper_Bound_D2

Lower_Bound_S1
Upper_Bound_S1

Lower_Bound_S2
Upper_Bound_S2







