function [W,K,Lower_Bound] = Sparse2_QCQP(A,B,C,X0,p,L,Q,R,epsi,alpha1,alpha2,solver)

cvx_begin 

if solver==0,
    cvx_solver mosek
elseif solver==1
    cvx_solver SDPT3
else
    cvx_solver sedumi
end


cvx_precision best




s=sum(sum(L));
n= size(A,1);
m= s;
r= s;


Ldiag=eye(s);


%--------------------------------------------------------------------------
%K=M*diag{Kdiag}*N

vart=1;
mloc=size(B,2);
rloc=size(C,1);

M=zeros(mloc,s);
N=zeros(s,rloc);

while vart<(s+1)
    for i=1:mloc,
        for j=1:rloc,
            if L(i,j) ~= 0
                M(i,vart)=1;
                N(vart,j)=1;
                vart=vart+1;
            end
        end
    end
end

Bdiag=B*M;
Cdiag=N*C;
%--------------------------------------------------------------------------
RR=Ldiag*ones(s,1);
total=0;
for i=1:s,
    for j=1:s,
        total = total + Ldiag(i,j);
        if (Ldiag(i,j)==1)
        addr(total,:)=[i j];
        end
    end
end


variable W(1+s+(p+1)*n+(p+1)*m+r*(p+1),1+s+(p+1)*n+(p+1)*m+r*(p+1)) symmetric
expression tt(p+1,m)

Kvec=W(2:(s+1),1);
Xvec=W(s+2:(s+2)+n*(p+1)-1,1);
Uvec=W((s+2)+n*(p+1):(s+2)+n*(p+1)+m*(p+1)-1,1);
Yvec=W((s+2)+n*(p+1)+m*(p+1):2+s+(p+1)*n+(p+1)*m+r*(p+1)-1,1);


[QT,LQT]=eig(Q);
[RT,LRT]=eig(M'*R*M);

Ab=QT'*A*QT;
Bb=QT'*Bdiag*RT;
Cb=Cdiag*QT';



minimize (trace(kron(eye(p+1),LQT)*W(s+2:1+s+n*(p+1),s+2:1+s+n*(p+1)))+...
    trace(kron(eye(p+1),LRT)*W(s+2+n*(p+1):1+s+(p+1)*(n+m),s+2+n*(p+1):1+s+(p+1)*(n+m)))+...
    alpha1*trace(W(2:s+1,2:s+1))+epsi*trace(W))

subject to

W(1,1) == 1;
Xvec(1:n)==QT'*X0;
W == semidefinite(1+s+(p+1)*n+(p+1)*m+r*(p+1));
alpha2*(diag(W(2:s+1,2:s+1)))<=1;

for i=1:p,
    Ab*Xvec(n*(i-1)+1:n*i)+Bb*Uvec(m*(i-1)+1:m*i)==Xvec(n*i+1:n*(i+1));
end

for i=1:p+1,
   Uvec(m*(i-1)+1:m*i)==inv(RT)*diag(W(2:s+1,1+s+n*(p+1)+r*(i-1)+1:1+s+n*(p+1)+r*i));
   
end

for i=1:p+1,
    Yvec(r*(i-1)+1:r*i)==Cb*Xvec(n*(i-1)+1:n*i);
end

cvx_end

K=zeros(mloc,rloc);
i=1;
while i<s+1
    for j=1:mloc,
        for q=1:rloc,
            if L(j,q)==1
                K(j,q)= Kvec(i);
                i=i+1;
            end
        end
    end
end

Lower_Bound = trace(kron(eye(p+1),LQT)*W(s+2:1+s+n*(p+1),s+2:1+s+n*(p+1)))+...
    trace(kron(eye(p+1),LRT)*W(s+2+n*(p+1):1+s+(p+1)*(n+m),s+2+n*(p+1):1+s+(p+1)*(n+m)))+...
    alpha1*trace(W(2:s+1,2:s+1));

K=full(K);



cvx_clear